=begin
#Skycoin REST API.

#Skycoin is a next-generation cryptocurrency.

The version of the OpenAPI document: 0.26.0
Contact: contact@skycoin.net
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.0.1

=end

require 'date'

module SkyApi
  class InlineResponse2002
    # CurrentCoinHourSupply is coins hours in non distribution addresses.
    attr_accessor :current_coinhour_supply

    # Coins distributed beyond the project.
    attr_accessor :current_supply

    # Distribution addresses which are locked and do not count towards total supply.
    attr_accessor :locked_distribution_addresses

    # MaxSupply is the maximum number of coins to be distributed ever.
    attr_accessor :max_supply

    # TotalCoinHourSupply is coin hours in all addresses including unlocked distribution addresses.
    attr_accessor :total_coinhour_supply

    # TotalSupply is CurrentSupply plus coins held by the distribution addresses that are spendable.
    attr_accessor :total_supply

    # Distribution addresses which count towards total supply.
    attr_accessor :unlocked_distribution_addresses

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'current_coinhour_supply' => :'current_coinhour_supply',
        :'current_supply' => :'current_supply',
        :'locked_distribution_addresses' => :'locked_distribution_addresses',
        :'max_supply' => :'max_supply',
        :'total_coinhour_supply' => :'total_coinhour_supply',
        :'total_supply' => :'total_supply',
        :'unlocked_distribution_addresses' => :'unlocked_distribution_addresses'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'current_coinhour_supply' => :'String',
        :'current_supply' => :'String',
        :'locked_distribution_addresses' => :'Array<String>',
        :'max_supply' => :'String',
        :'total_coinhour_supply' => :'String',
        :'total_supply' => :'String',
        :'unlocked_distribution_addresses' => :'Array<String>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `SkyApi::InlineResponse2002` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `SkyApi::InlineResponse2002`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'current_coinhour_supply')
        self.current_coinhour_supply = attributes[:'current_coinhour_supply']
      end

      if attributes.key?(:'current_supply')
        self.current_supply = attributes[:'current_supply']
      end

      if attributes.key?(:'locked_distribution_addresses')
        if (value = attributes[:'locked_distribution_addresses']).is_a?(Array)
          self.locked_distribution_addresses = value
        end
      end

      if attributes.key?(:'max_supply')
        self.max_supply = attributes[:'max_supply']
      end

      if attributes.key?(:'total_coinhour_supply')
        self.total_coinhour_supply = attributes[:'total_coinhour_supply']
      end

      if attributes.key?(:'total_supply')
        self.total_supply = attributes[:'total_supply']
      end

      if attributes.key?(:'unlocked_distribution_addresses')
        if (value = attributes[:'unlocked_distribution_addresses']).is_a?(Array)
          self.unlocked_distribution_addresses = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          current_coinhour_supply == o.current_coinhour_supply &&
          current_supply == o.current_supply &&
          locked_distribution_addresses == o.locked_distribution_addresses &&
          max_supply == o.max_supply &&
          total_coinhour_supply == o.total_coinhour_supply &&
          total_supply == o.total_supply &&
          unlocked_distribution_addresses == o.unlocked_distribution_addresses
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [current_coinhour_supply, current_supply, locked_distribution_addresses, max_supply, total_coinhour_supply, total_supply, unlocked_distribution_addresses].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        SkyApi.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
